/**
 * @module dixim
 * @submodule server
 */
dixim.namespace('dixim.server');

/**
 * @module server
 * @submodule permission-menu-view
 */

(function() {
var ParentalMenuView;
var prototype;
var superConstructor;
var MenuView = dixim.common.MenuView;
var _ = dixim.ctt.ResourceBundle.get;

/**
 * @class ParentalMenuView
 * @constructor
 * @param {Object} configs
 */
ParentalMenuView = function(configs) {
    MenuView.call(this, configs);
};

dixim.inherit(ParentalMenuView, MenuView);
dixim.server.ParentalMenuView = ParentalMenuView;
prototype = ParentalMenuView.prototype;
superConstructor = ParentalMenuView.superConstructor;

var EDIT_SETTING = 'editSetting';
var EDIT_PIN = 'editPin';
var PREV = 'prev';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    configs.title = _('server_menu_parental');
    configs.menuList = [
        {
            strId: 'server_parental_menu_edit_setting_title',
            eventParam: EDIT_SETTING,
        },
        {
            strId: 'server_parental_menu_edit_pin_title',
            eventParam: EDIT_PIN,
        },
    ];

    superConstructor.prototype._initialize.call(this, configs);
};

}());
