(function() {
    var Utils = dixim.ctt.util.Utils;
    var $ = dixim.ctt.jQuery;

    var isIpodTouch = (Utils.isUserAgent('ipod') && Utils.isUserAgent('touch') && Utils.isUserAgent('iphone\ os\ 7'));
    var checkWindowResize = function(heights) {
        var articleHeight = $(window).height() - $('header').height();
        var articleDifferentHeight = (articleHeight === heights.articleHeight);
        var focusInput = $('input').is(':focus');

        if (focusInput) {
            $(window).on('touchmove.noScroll', function(e) {
                e.preventDefault();
            });
        } else {
            $(window).off('.noScroll');
        }
        if (articleDifferentHeight) return false;
        if (focusInput && Utils.isUserAgent('android')) return false;
        if (focusInput && isIpodTouch) return false;

        return true;
    };
    var windowResize = function() {
        var heights = {};
        var winHeight = $(window).height();
        var headerHeight = $('header').height();
        var dialog_height;
        var keyboardSize;

        heights.winHeight = winHeight;
        heights.headerHeight = headerHeight;
        heights.articleHeight = winHeight - headerHeight;

        $('article').height(heights.articleHeight);
        if (checkWindowResize(heights)) {
            if ($('input:focus').length > 0) {
                $('input:focus').blur();
            }
        }
        if ($('.ui-dialog').length > 0) {
            dialog_height = $('.ui-dialog:last-child > .ui-dialog-contain').height();

            $('.ui-dialog:last-child').css('padding-top', (winHeight - dialog_height) / 2);
            $('.ui-dialog:last-child').css('padding-bottom', (winHeight - dialog_height) / 2);
        }
    };
    var aHeight = $(window).height() - $('header').height();
    var focusFlag = false;
    var focusTop;
    var editingFocusId = '';
    var operateInputFocus = function() {
        var winHeight = $(window).height();
        var headerHeight = $('header').height();
        var keyboardSize;
        var articleHeight = winHeight - headerHeight;
        var isFocus = ($('input:focus').length > 0)

        if (isFocus && (! focusFlag)) {
            focusTop = $('input:focus').offset().top - headerHeight;
            keyboardSize = aHeight - articleHeight;
            if (articleHeight < focusTop+$('input:focus').height()+50) {
                focusFlag = true;
                editingFocusId = $('input:focus').prop('id');
                $('body').append('<input type="text" class="soft_keyboard" />');
                $('.soft_keyboard')
                    .css('top', [winHeight - 50, 'px'].join(''))
                    .css('width', '100%')
                    .css('height', '50px')
                    .css('position', 'absolute')
                    .css('z-index', '99999');
                $('.soft_keyboard').val($('input:focus').val());
                $('.soft_keyboard').focus();
            }
        } else if (! isFocus) {
            focusFlag = false;
            if (editingFocusId !== '') {
                if ($('.soft_keyboard').length > 0) {
                    $(['#', editingFocusId].join('')).val($('.soft_keyboard').val());
                }
                editingFocusId = '';
            }
            $('.soft_keyboard').remove();
        }
        if (isFocus) {
            if ((editingFocusId !== '') && ($('input:focus').prop('id') !== '') && (editingFocusId !== $('input:focus').prop('id')) && focusFlag) {
                if ($('.soft_keyboard').length > 0) {
                    $(['#', editingFocusId].join('')).val($('.soft_keyboard').val());
                    $('.soft_keyboard').remove();
                }
                editingFocusId = $('input:focus').prop('id');
            }
        }
        $('article').height(articleHeight);
        aHeight = articleHeight;
    };

    setInterval(function() {
        windowResize();
    }, 200);

    if (Utils.isUserAgent('android\ 5')) {
        setInterval(function() {
            operateInputFocus();
        }, 200);
        $(window).on('orientationchange', function() {
            if($('input:focus').length > 0) {
                if ($('.soft_keyboard').length > 0) {
                    $(['#', editingFocusId].join('')).val($('.soft_keyboard').val());
                }
                $('input:focus').blur();
                aHeight = $(window).height() - $('header').height();
                focusFlag = false;
                editingFocusId = '';
            }
        });
    }

    $('*').keypress(function(e) {
        if ((e.which && e.which === 13) || (e.keyCode && e.keyCode === 13)) {
            return false;
        }
    });

    $(document).on('contextmenu', function(e) {
        e.preventDefault();
    });

    document.ondragstart = function() {return false;};
})();
