/**
 * @module dixim
 * @submodule server
 */
dixim.namespace('dixim.server');

/**
 * @module server
 * @submodule progress-dialog-view
 */

(function() {
var ProgressDialogView;
var prototype;
var superConstructor;
var _ = dixim.ctt.ResourceBundle.get;
var ProgressModalDialogView = dixim.common.ProgressModalDialogView;
var Enum = dixim.ctt.util.Enum;

/**
 * @class ProgressDialogView
 * @constructor
 * @param {Object} configs
 */
ProgressDialogView = function(configs) {
    ProgressModalDialogView.call(this, configs);
};

dixim.inherit(ProgressDialogView, ProgressModalDialogView);
dixim.server.ProgressDialogView = ProgressDialogView;
prototype = ProgressDialogView.prototype;
superConstructor = ProgressDialogView.superConstructor;

var Mode = Enum.fetch('PROGRESS');

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    var mode = configs.mode || Mode.CONTENTS;
    var contents = configs.contents || [];

    configs = configs || {};

    configs.id = configs.id || '';
    configs.id = [configs.id, 'progress-dialog-'].join('');

    switch(mode) {
        case Mode.SYNC_PUBLIC:
            configs.title = _('server_public_folder_sync_title');
            configs.description = _('server_public_folder_sync_description', contents.length);
            configs.nameKey = 'path';
            configs.progressStr = _('server_public_folder_sync_progress')
            break;
    }

    superConstructor.prototype._initialize.call(this, configs);
};

}());
